import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 *  Ŭ Ŭ Ŭ̴.
 *  Ŭ Paddle, Brick, ,Counter, GameBoard Ѵ.
 *  map   Ÿµ 0 Ϲݺ, 1 ö̴.
 * 迭  ν ȭ鿡 Ÿ     ִ.
 *  check   θ Ÿ boolean  ̴.
 *  brickNum    Ÿ ̴.
 * brickNum 0 Ǹ gameSet() ޼带 Ų.
 */
public class Board extends World
{
    static final int[][] map =  new int[][] {{1, 1, 1, 1, 1, 1},  //  迭
                                             {1, 0, 0, 0, 0, 1},
                                             {1, 0, 0, 0, 0, 1},
                                             {1, 1, 1, 1, 1, 1}};
    private Paddle paddle;
    private Brick brick;
    private Counter[] counter;
    private GameBoard gameBoard;
    
    private boolean check = false;
    private int brickNum = Brick.BRICK_HEIGHT * Brick.BRICK_WIDTH;
    
    /**
     * ̴. Paddle Brick  Counter Ѵ.
     * ó ϱ  GameBoard   ǥõȴ.
     */
    public Board()
    {    
        super(880, 500, 1);
        setPaintOrder ( Ball.class, Smoke.class );
        
        paddle = new Paddle();
        addObject ( paddle, getWidth() / 2, getHeight() - 60);
        
        brick = new Brick(0);
        addObject(brick, getWidth(), getHeight());
        brick.makeBricks();
        
        counter = new Counter[2];
        
        counter[0] = new Counter("Left bricks : ", brickNum);
        addObject(counter[0], 100, getHeight() - 10);
        
        counter[1] = new Counter("Left marbles : ", 3);
        addObject(counter[1], getWidth() - 30 , getHeight() - 10);
        
        gameBoard = new GameBoard("GameStart1.png");
        addObject(gameBoard, getWidth()/2, getHeight()/2);
    }
    
    /**
     * act ư   Ǵ ޼̴.
     * act ư  gameBoard .
     */
    public void started(){
        removeObject(gameBoard);
    }
        
    /**
     *  Ʒκп Ҵ Ȯϴ ޼̴.
     *   0̸ gameSet ޼带 ȣϰ
     * ƴϸ  ϳ δ.
     */
    public void ballIsOut()
    {        
        if(counter[1].isZero()){
            gameSet();
        }
        else{
            counter[1].decreaseValue();
            paddle.newBall();
        }
    }

    /**
     *   ̴ ޼̴.
     *   0 gameSet ޼带 ȣѴ.
     */
    public void breakBrick()
    {
        counter[0].decreaseValue();
        if(counter[0].isZero())
        {
            gameSet();
        }
    }
    
    /**
     *   ޼̴.
     *    0 'Game Clear'  ߰
     * ƴϸ 'Game Over'  .
     */
    public void gameSet()
    {
        if(counter[0].isZero()){
            addObject(new GameBoard("GameClear.png"), getWidth()/2, getHeight()/2);
        }
        else{
            addObject(new GameBoard("GameOver.png"), getWidth()/2, getHeight()/2);
        }
        check = true;
    }
    
    /**
     *   θ Ÿ  check ȯִ ޼̴.
     */
    public boolean getCheck()
    {
        return check;
    }
}
