import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * ȭ  Ÿ MetalBrick, NormalBrick Ŭ̴.
 *  迭 Brick[BRICK_HEIGHT][BRICK_WIDTH]  Ÿ ̰
 * count    ¾ƾ  Ƚ Ÿ ̴.
 */
public class Brick  extends Actor
{
    static final int BRICK_HEIGHT = 4;
    static final int BRICK_WIDTH = 6;
    private Brick[][] brick = new Brick[BRICK_HEIGHT][];
    private int count;
    
    /**
     * Brick ̴.
     * count ʱⰪ Ѵ.
     * ö 2, Ϲ  1 ʱȭѴ.
     */
    public Brick(int count){
        this.count = count;
    }
    
    /**
     *   ޼̴.
     * Board.map[i][j] == 1̸ ö ϰ
     * Board.map[i][j] == 0̸ Ϲݺ Ѵ.
     */
    public void makeBricks(){
        for(int i=0;i<BRICK_HEIGHT;i++){
            brick[i] = new Brick[BRICK_WIDTH];
            for(int j=0;j<BRICK_WIDTH;j++){
                if(Board.map[i][j] == 1){
                    brick[i][j] = new MetalBrick(2);
                    getWorld().addObject(brick[i][j], 165 + j*110, 80 + i*30);
                }
                else{
                    brick[i][j] = new NormalBrick(1);
                    getWorld().addObject(brick[i][j], 165 + j*110, 80 + i*30);
                }
            }
        }
    }
    
    /**
     * count  1 ҽŰ ޼̴.
     */
    public void decreaseCount(){
        count--;
    }
    
    /**
     * count  0 θ Ȯϴ boolean ޼̴.
     */
    public boolean isZero(){
        if(count == 0){
            return true;
        }
        else{
            return false;
        }
    }
    
    /**
     *  ϴ ޼̴.
     */
    public void remove(){
        getWorld().removeObject(this);
    }
}
