import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Paddle Ÿ Ŭ̴.
 * MAX_SPEED Paddle ִ ̵ӵ Ÿ ̴.
 */
public class Paddle extends Actor
{
    private final int MAX_SPEED = 10;
    private Ball myBall;  // used before ball gets released

    /**
     * Paddle 忡 Ÿ Ǵ ޼̴.
     * ޼尡 Ǹ newBall ޼带 ȣѴ.
     */
    public void addedToWorld(World world)
    {
        newBall();
    }
    
    /**
     * act ư  ѹݺǴ ޼̴.
     * , , , Ʒ Ű    ̵Ѵ.
     * spacebar ư  releaseBall ޼带 ȣѴ.
     */
    public void act() 
    {
        if(!((Board) getWorld()).getCheck()){
            if (Greenfoot.isKeyDown ("left")) {
                moveLR(-MAX_SPEED);
            }
            if (Greenfoot.isKeyDown ("right")) {
                moveLR(MAX_SPEED);
            }
        
            if (Greenfoot.isKeyDown ("up") && getY() > 300) {
                moveUD(-(MAX_SPEED-5));
            }
            if (Greenfoot.isKeyDown ("down") && getY() < 480) {
                moveUD(MAX_SPEED-5);
            }
        
           if (haveBall() && Greenfoot.isKeyDown ("space")) {
              releaseBall();
            }
        }
    }
    
    /**
     * Paddle   ̰ ϴ ޼̴.
     *   ߻ ʾҴٸ  Բ δ.
     */
    private void moveLR(int dist)
    {
        setLocation (getX() + dist, getY());
        if (myBall != null) {
            myBall.moveLR (dist);
        }
    }
    
    /**
     * Paddle  Ʒ ̰ ϴ ޼̴.
     *   ߻ ʾҴٸ  Բ δ.
     */
    private void moveUD(int dist)
    {
        setLocation (getX(), getY() + dist);
        if (myBall != null) {
            myBall.moveUD (dist);
        }
    }
    
    /**
     *   ϴ ޼̴.
     *  Paddle ٷ ʿ Ѵ.
     */
    public void newBall()
    {
        myBall = new Ball();
        getWorld().addObject (myBall, getX(), getY()-20);
    }
        
    /**
     *  ߻Ǿ θ Ÿ boolean ޼̴.
     */
    public boolean haveBall()
    {
        return myBall != null;
    }
        
    /**
     *  ߻ϴ ޼̴.
     */
    public void releaseBall()
    {
        myBall.release();
        myBall = null;
    }
}
