import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

import java.awt.Color;
import java.awt.Graphics;

/**
 *   ,    ǥִ Ŭ̴.
 * value       Ÿ ̴.
 * text ̹ Ÿ ڿ ޴ ̴.
 * stringLength ̹ ũ⸦ Ÿ ̴.
 */
public class Counter  extends Actor
{

    private static final Color textColor = new Color(255, 0, 0);
    
    private int value;
    private String text;
    private int stringLength;
    
    /**
     * Counter ̴.
     * Ű prefix, value ޾ ̹ value ʱȭϰ
     * ̹ ǥѴ.
     */
    public Counter(String prefix, int value)
    {
        text = prefix;
        this.value = value;
        stringLength = (text.length() + 2) * 10;

        setImage(new GreenfootImage(stringLength, 16));
        GreenfootImage image = getImage();
        image.setColor(textColor);

        updateImage();
    }
    
    /**
     * act ư   ѹݺǴ ޼̴.
     * ̹ ƮŲ.
     */
    public void act()
    {
        updateImage();
    }
    
    /**
     * Count ̹ ƮŰ ޼̴.
     * text + value · Ÿ.
     */
    public void updateImage()
    {
        GreenfootImage image = getImage();
        image.clear();
        image.drawString(text + value, 1, 12);
    }
    
    /**
     * value  0 θ Ÿ boolean ޼̴.
     */
    public boolean isZero()
    {
        boolean result=false;
        
        if(value==0){
            result=true;
        }
        
        return result;
    }
    
    /**
     * value  1ŭ ҽŰ ޼̴.
     */
    public void decreaseValue()
    {
        value--;
    }
}
