import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Ball ο Ǵ Smoke Ŭ̴.
 * image Smoke ̹    ð   ũ⸦ ҽŰ  Ѵ.
 * fade ʱ Smoke ũ⸦ Ÿ ̴.
 */
public class Smoke  extends Actor
{
    private GreenfootImage image;   // the original image
    private int fade;               // the rate of fading

    /**
     * Smoke ̴.
     * Smoke ̹ image ϰ
     * Smoke ũ⸦ 1~3    Ѵ.
     */
    public Smoke()
    {
        image = getImage();
        fade = Greenfoot.getRandomNumber(4) + 1;  // 1 to 3
        if (fade > 3) {
          fade = fade - 2;
        }
    }
    
    /**
     * act ư   ݺǴ ޼̴.
     * shrink ޼带 ȣѴ.
     */
    public void act() 
    {
        shrink();
    }
    
    /**
     * Smoke ũ⸦ ٿ ޼̴.
     * Smoke ũ⸦ ̴ٰ  ũⰡ 10 ̸ Ǹ Ѵ.
     */
    private void shrink()
    {
        if(getImage().getWidth() < 10) {
            getWorld().removeObject(this);
        }
        else {
            GreenfootImage img = new GreenfootImage(image);
            img.scale ( getImage().getWidth()-fade, getImage().getHeight()-fade );
            setImage (img);
        }
    }
}
